function H=c0continuity(P,E,PE,d)
%  H=c0continuity(P,E,PE,d)
%This function is to compute a matrix of the C0 continuity condition of 
%the coefficients of a voronoi spline of order d. It is written by Dr.
%Ming-Jun Lai on Nov. 5, 2014. 
n=size(E,1);
[l,m]=size(P);[l,L]=vslength(P,m,d);
H=[];
for i=1:n
    pe=PE(:,i); I=find(pe); 
    s=size(I);
    if s(1)==2
       k1=I(1); k2=I(2); 
       [n1,l]=vslength(P,k1,d); [n2,l]=vslength(P,k2,d);
       e=E(i,:);
       p1=P{k1}; [l,m1]=size(p1);
       p1=[p1,p1(1)];
       for j=1:m1
           if e==[p1(j),p1(j+1)]
               break
           end
           if e==[p1(j+1),p1(j)]
               break
           end
       end
       if j<m1
       i1a=n1+d*(j-1)+1; i1b=n1+d*(j-1)+2;i1c=n1+d*(j-1)+3; 
       else 
       i1a=n1+d*(j-1)+1; i1b=n1+d*(j-1)+2;i1c=n1+1;
       end
       p2=P{k2}; [l,m2]=size(p2);
       p2=[p2,p2(1)];
       for j=1:m2
           if e==[p2(j),p2(j+1)]
               break
           end
           if e==[p2(j+1),p2(j)]
               break
           end
       end
       if j<m2
       i2a=n2+d*(j-1)+3; i2b=n2+d*(j-1)+2;i2c=n2+d*(j-1)+1;
       else 
       i2a=n2+1;  i2b=n2+d*(j-1)+2;i2c=n2+d*(j-1)+1;
       end
       [i2a,i2b,i2c];
       h1=sparse(1,L);  h2=sparse(1,L);  h3=sparse(1,L);
       h1(1,i1a)=1;h2(1,i1b)=1; h3(1,i1c)=1;
       h1(1,i2a)=-1;h2(1,i2b)=-1; h3(1,i2c)=-1;
       H=[H;h1;h2;h3];
    end
end
       