function F=coeffv(V,P,f,CaseNumber)
%   F=coeffv(V,P,f,caseNumber)
% It produces the coefficient vector of the Lagrange interpolation over a list 
% of convex polygons interpolating f at vertices and midpoints of polygons.
%
% Author: Ming-Jun Lai
% e-mail: mjlai@math.uga.edu
% Created: Dec. 2014, using Matlab R2014b
%This is based on the results in the publication:
%  Polygonal spline spaces and  the numerical solution of the Poisson equation,
%    Michael Floater and Ming-Jun Lai
%  SIAM J. Numerical Analysis, accepted on  2015.
%
F=[];
[m,n]=size(P);
for i=1:n
    p=P{i}; m=size(p,2); v=[];
    for j=1:m
    v=[v;V(p(j),:)];
    end
    F1=feval(f,v(:,1),v(:,2),CaseNumber);
    u=[];
    for j=1:m-1
    u=[u;v(j,:)+v(j+1,:)];
    end
    u=[u;v(m,:)+v(1,:)];
    u=u/2;
    F2=feval(f,u(:,1),u(:,2),CaseNumber);
    for j=1:m
    F=[F;F1(j);F2(j)];
    end
end

    
