function [G,B]=dirichlet(V,P,E,PE,d,g,varargin)
%  [G,B]=dirichletV,P,PE,d,g,varargin)
%This function is to compute a matrix of the C0 continuity condition of 
%the coefficients of a voronoi spline of order d. It is written by Dr.
%Ming-Jun Lai on Feb. 5, 2015. 
n=size(E,1);
[l,m]=size(P);[l,L]=vslength(P,m,d);
B=[]; G=[];
for i=1:n
    pe=PE(:,i); I=find(pe); 
    s=size(I);
    if s(1)==1
       k1=I(1);  
       [n1,l]=vslength(P,k1,d); 
       e=E(i,:);
       p1=P{k1}; [l,m1]=size(p1);
       p1=[p1,p1(1)];
       for j=1:m1
           if e==[p1(j),p1(j+1)]
               loc=[p1(j),p1(j+1)];
               break
           end
           if e==[p1(j+1),p1(j)]
                loc=[p1(j),p1(j+1)];
               break
           end
       end
       if j<m1
       i1a=n1+d*(j-1)+1; i1b=n1+d*(j-1)+2;i1c=n1+d*(j-1)+3; 
       else 
       i1a=n1+d*(j-1)+1; i1b=n1+d*(j-1)+2;i1c=n1+1;
       end
       b=sparse(1,L);
       b(1,i1a)=1;
       B=[B;b]; 
       b=sparse(1,L);
       b(1,i1b)=1;
       B=[B;b]; 
       b=sparse(1,L);
       b(1,i1c)=1;
       B=[B;b]; 
       u1=V(loc(1),:); u2=V(loc(2),:);
       G=[G;feval(g,u1(1),u1(2),varargin{:})];
       G=[G;feval(g,(u1(1)+u2(1))/2,(u1(2)+u2(2))/2,varargin{:})];
       G=[G;feval(g,u2(1),u2(2),varargin{:})];
    end
end
       
   
       