function z=laplace(x,y,k)
% Author: Ming-Jun Lai
% e-mail: mjlai@math.uga.edu
% Created: Dec. 2014, using Matlab R2014b
% Copyright 2014.
switch k
case 1
    z = -4*(x.^2+y.^2-1)./((1+x.^2+y.^2).^3);
case 123
    u=1-(x.^2+y.^2);
    I=find(abs(u)>1e-14);
     z=10^7*ones(size(x));
     z(I)=(2-(x(I).^2+y(I).^2))./(u(I).^(3/2));
case 2
     z = -6*x.*y.*(x.^2+y.^2);
case 22
    z=-8*ones(size(x));
case 3
     z =-12*(x.^2+y.^2);
case 4
  z= 4*pi*(-cos(pi*(x.*x+y.*y))+pi*(x.*x+y.*y).*sin(pi*(x.*x+y.*y)));
case 41
  z= 4*pi*(-2*cos(2*pi*(x.*x+y.*y))+4*pi*(x.*x+y.*y).*sin(2*pi*(x.*x+y.*y)));
case 410
     z=2*sin(x).*sin(y);
case 5
  z =-40*exp(-x.*x-y.*y).*(x.*x+y.*y-1);
case 6
  z = -(20+20*x-2*y-32*x.*x-48*x.*y-80*y.^2-158*x.^3-156*x.*x.*y-186*x.*y.*y-260*y.^3);    
case 8 %An approximation of Delta function at (0,0)
    eps=0.1;
    z = zeros(size(x));
    if x.*x+y.*y <eps 
    z = exp(1-eps./(eps-x.^2+y.^2));
    end
case 88
    z=sin(pi*(x.^2+y.^2));
case {89,44}
        z=zeros(size(x));
case 9 %This example is belong to Qianying Hong
    z=(x<=0 & y<=0).*(1*phi_1(y)+1*phi_1(x))+(x<0 & y>=0).*(1*phi_2(y)+(-1)*phi_1(x))+ ...
   (x>=0 & y>0).*((-1)*phi_2(x)+(-1)*phi_2(y))+(x>0 & y<0).*((1)*phi_2(x)+(-1)*phi_1(y));
case 10 %This example is belong to David Prager
 if y<0
     z=-(56*(x.^6)+(12*y.^2));
 else
     z=-((56*(x.^6))+(6*y));
 end

case 18 %This is an example from Jeremy Praissmann
   x(abs(x) < 1.0000e-018)=1.0000e-018;
   y(abs(y) < 1.0000e-018)=1.0000e-018;
   z = -6.*x.*sin(1./x)+4.*cos(1./x)+1./x.*sin(1./x)-6.*y.*sin(1./y)+4.*cos(1./y)+1./y.*sin(1./y);
   z(abs(x)<=1.0000e-018)=0;
   z(abs(y)<=1.0000e-018)=0;
case 118 %This is a modification of the Praissmann example.
    z=zeros(size(x));
    I=find(abs(x)>1e-5 & abs(y)>1e-5);
       z(I) = -6*x(I).*sin(1./x(I))+4*cos(1./x(I))+1./x(I).*sin(1./x(I)) - ...
           6*y(I).*sin(1./y(I))+4*cos(1./y(I))+1./y(I).*sin(1./y(I));
case 19
       z=zeros(size(x));
   I=find(x(:)<=0.5); J=find(x(:)>0.5);
   z(I) = z(I)-4*(cos(x(I).^2 + y(I).^2) - (x(I).^2 +y(I).^2).*...
         (sin(x(I).^2 + y(I).^2)) );
   z(I)=-z(I);
   z(J) = z(J) + 2*y(J).*sin(x(J).*y(J))+((y(J).^2+x(J).^2).*(x(J)-.5)).*cos(x(J).*y(J));
   z(J)=-z(J);
case 11
  z= 8*ones(size(x))-8./(x.*x+y.*y+1)- ... 
      8*(x.*x+y.*y).^2./((x.*x+y.*y+1).^3); 
case 12
    z = 4./(1+x.*x+y.*y)- 4*(x.*x+y.*y)./((1+x.*x+y.*y).^2);
case 13
    eps=2.001;
    z=4*(2*x.^2+2*y.^2+eps)./((x.^2+y.^2+1).^2) - ...
        8*(x.^2+y.^2).*(x.^2+y.^2+eps)./((x.^2+y.^2+1).^3); 
    
case 108 %A function with a lot of oscilations.
    n=10;
    z=2*n*n*pi*pi*sin(n*pi*x).*sin(n*pi*y);
end


function z=phi_1(x)
z=-(1+x).^2/2+1/2;

function z=phi_2(x)
z=(x-1).^2/2-1+1/2;
