function K = locStiff(V1,V2,V3,Mat,d)
%        K = locStiff(V1,V2,V3,Mat,d)
% This function computes the local stiffnes matrix.
% This matlab program is copyrighted @2001 by Ming-Jun Lai and Paul Wenston
% through University of Georgia Research Foundation, Inc..
m = (d+1)*(d+2)/2;
Id = eye(m);
vx = [1,0];
vy = [0,1];
[lam1x,lam2x,lam3x] = tcord(V1,V2,V3,vx);
[lam1y,lam2y,lam3y] = tcord(V1,V2,V3,vy);
Dx = dirder(Id,lam1x,lam2x,lam3x);
Dy = dirder(Id,lam1y,lam2y,lam3y);
K = abs(triarea(V1,V2,V3))*(Dx'*Mat*Dx + Dy'*Mat*Dy);