function [Vn,Qn]=refineQ(V,Q)
%        [Vn,Qn]=refineQ(V,Q)
%This is a matlab program to refine the quadrangulation (V,Q) 
 [l,m] = size(Q); 
 n = size(V,1); 
 Vn = V;
 Qn = {};
%
% We shall refine the quadrangles one at a time, adding new vertices
% as they appear.
%
 for i=1:m
     q=Q{i};
   x_12=(V(q(1),:)+V(q(2),:))/2;
   x_23=(V(q(2),:)+V(q(3),:))/2;
   x_34=(V(q(3),:)+V(q(4),:))/2;
   x_41=(V(q(4),:)+V(q(1),:))/2;

% We have just computed the midpoints of the sides of quadrangle #i
% We must determine if these vertices are in our list yet.

   place12=0;
   place23=0;
   place34=0;
   place41=0;
   for k=1:n 
     if (x_12 == Vn(k,:))
       place12=k;
     end; 
     if (x_23 == Vn(k,:))
       place23=k;
     end;
     if (x_34 == Vn(k,:))
       place34=k;
     end;
     if (x_41 == Vn(k,:))
       place41=k;
     end;
   end;
   if place12== 0
     n=n+1; 
     place12=n;
     Vn = [Vn;x_12];
   end;
   if place23== 0
     n=n+1;
     place23=n;
     Vn=[Vn;x_23];
   end;
   if place34== 0
     n=n+1;
     place34=n;
     Vn=[Vn;x_34];
   end;
   if place41==0 
     n=n+1;
     place41=n;
     Vn=[Vn;x_41];
   end;
   Vn = [Vn;(V(q(1),:)+V(q(2),:)+V(q(3),:)+V(q(4),:))/4];
   n = n+1;
   Q1=[q(1), place12, n, place41];
   Q2=[place12, q(2), place23, n];
   Q3=[place41, n, place34, q(4)];
   Q4=[n, place23, q(3), place34];
   nQ1={Q1,Q2,Q3,Q4};
   if isempty(Qn)
       Qn=nQ1;
   else
       Qn={Qn{:},nQ1{:}};
   end
 end;
 
